using System;

class Program {

  struct Pacijent
  {
    public string grupa;
    public int brJedinica;
    public int[] brGrupa;
  }

  public static void Main (string[] args) {
    int N = Convert.ToInt32(Console.ReadLine());
    string[] s = Console.ReadLine().Split();
    int O = Convert.ToInt32(s[0]), A = Convert.ToInt32(s[1]), B = Convert.ToInt32(s[2]), AB = Convert.ToInt32(s[3]);
    int[] jed = new int [N];

    Pacijent[] pacijenti = new Pacijent[N];
    for(int i = 0;i < N; i++)
    {
      s = Console.ReadLine().Split();
      pacijenti[i].grupa = s[0];
      pacijenti[i].brJedinica = Convert.ToInt32(s[1]);
      jed[i] = pacijenti[i].brJedinica;
      pacijenti[i].brGrupa = new int [4];
    }

    for(int i = 0;i < N; i++)
    {
      for(int j = 0;j < jed[i]; j++)
      {
        if(pacijenti[i].grupa == "O")
        {
          pacijenti[i].brGrupa[0]++;
          pacijenti[i].brJedinica--;
          O--;
        }
        else if(pacijenti[i].grupa == "A")
        {
          if(A > 0) 
          {
            pacijenti[i].brGrupa[1]++;
            A--;
          }
          else
          {
            pacijenti[i].brGrupa[0]++;
            O--;
          }
          pacijenti[i].brJedinica--;
        }
        else if(pacijenti[i].grupa == "B")
        {
          if(B > 0) 
          {
            pacijenti[i].brGrupa[2]++;
            B--;
          }
          else
          {
            pacijenti[i].brGrupa[0]++;
            O--;
          }
          pacijenti[i].brJedinica--;
        }
        else
        {
          if(AB > 0) 
          {
            pacijenti[i].brGrupa[3]++;
            AB--;
          }
          else if(A > 0)
          {
            pacijenti[i].brGrupa[1]++;
            A--;
          }
          else if (B > 0)
          {
            pacijenti[i].brGrupa[2]++;
            B--;
          }
          else
          {
            pacijenti[i].brGrupa[0]++;
            O--;
          }
          pacijenti[i].brJedinica--;
        }
      }
    }
    if(O < 0)
    {
      Console.WriteLine("nemoguce");
    }
    else
    {
      Console.WriteLine("moguce");
      for(int i = 0;i < N; i++)
      {
        for(int j = 0;j < 4; j++)
        {
          Console.Write(pacijenti[i].brGrupa[j] + " ");
        }
        Console.WriteLine();
      }
    }
  }
}